(*******************************************************************************
  Copyright 2014-2015 MIT Lincoln Laboratory
  Project:     SPAR
  Author:      Alley Stoughton
  Description: Part of Private Count Retrieval (PCR) Protocol Proof
*******************************************************************************)

(* FMapAux.ec *)

(* Auxiliary Lemmas for Finite Maps *)

prover "Alt-Ergo". timeout 2.  (* set prover and timeout *)

require import Option.
require import OptionAux.
require import FMap.
require import FSet.

lemma InDomSomeOGet (mp : ('a, 'b)map, x : 'a, y : 'b) :
  mem x (dom mp) => mp.[x] = Some(oget mp.[x]).
proof.
intros H1.
cut H2 : mp.[x] <> None.
  apply mem_dom => //.
cut H3 : exists (z : 'b), mp.[x] = Some z.
  apply NotNoneImpliesExistsSome => //.
elim H3 => z H3.
rewrite H3; rewrite oget_some; reflexivity.
qed.

lemma NotInDomNone (mp : ('a, 'b)map, x : 'a) :
  ! mem x (dom mp) => mp.[x] = None.
proof.
intros H1.
case (mp.[x] = None) => // H2.
cut H3 : mem x (dom mp).
  apply mem_dom => //.
apply (negbTE (mem x (dom mp))) => //.
qed.

lemma NotInDomRM (mp : ('a, 'b)map, x : 'a) :
  ! mem x (dom mp) => rm x mp = mp.
proof.
intros H1.
apply map_ext => y.
case (x = y) => H2.
(* x = y *)
rewrite - H2. rewrite get_rm_eq; apply eq_sym; apply NotInDomNone => //.
(* x <> y *)
apply get_rm_neq => //.
qed.
