(*******************************************************************************
  Copyright 2014-2015 MIT Lincoln Laboratory
  Project:     SPAR
  Author:      Alley Stoughton
  Description: Part of Private Count Retrieval (PCR) Protocol Proof
*******************************************************************************)

(* Union.ec *)

(* Disjoint Unions *)

require import Bool.

type ('a, 'b)union = [Left of 'a | Right of 'b].

op isLeft (un : ('a, 'b)union) : bool =
  with un = Left x  => true
  with un = Right x => false.

op leftOf (un : ('a, 'b)union) (err : 'a) : 'a =
  with un = Left x  => x
  with un = Right x => err.

op rightOf (un : ('a, 'b)union) (err : 'b) : 'b =
  with un = Left x  => err
  with un = Right x => x.

